"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.defaultSortClassList = void 0;
const fs = __importStar(require("fs"));
const prefixCache = {};
// lazily init twClasses, so if on some point we want to use a custom sort-function we do not need to load this file
let twClasses;
function getTwClasses(opts) {
    if (!twClasses) {
        twClasses = fs.existsSync(opts.sortClassNamesOrderFile)
            ? Object.fromEntries(fs
                .readFileSync(opts.sortClassNamesOrderFile, 'utf8')
                .split('\n')
                .map((c, i) => [c.replace('\r', ''), i]))
            : {};
    }
    return twClasses;
}
function classNameToIndex(opts, className) {
    return getTwClasses(opts)[className] || -1;
}
function defaultSortClassList(opts) {
    let prefixes = prefixCache[opts.sortClassNamesPrefixes];
    if (!prefixes) {
        prefixes = opts.sortClassNamesPrefixes.split(',');
        prefixCache[opts.sortClassNamesPrefixes] = prefixes;
    }
    return (classes) => {
        if (!Array.isArray(classes)) {
            classes = classes
                .split(' ')
                .map(c => c.trim())
                .filter(Boolean)
                // ignore slash classes (which are inserted by default by this plugin)
                .filter(cn => cn !== opts.sortClassNamesUnknownClassesSeparator);
        }
        const orderedClassNameParts = [];
        const noPrefixClassNames = [];
        const prefixesHelper = prefixes.map(p => {
            return { prefix: p, classNames: [] };
        });
        classes.forEach(cn => {
            for (const { prefix, classNames } of prefixesHelper) {
                if (cn.startsWith(prefix)) {
                    classNames.push(cn);
                    return;
                }
            }
            // wenn kein prefix passt, füge es den allgemeinen Klassen hinzu:
            noPrefixClassNames.push(cn);
        });
        [
            { prefix: '', classNames: noPrefixClassNames },
            ...prefixesHelper,
        ].forEach(({ classNames, prefix }) => {
            const res = {};
            classNames.forEach(cn => {
                // nutze den bereinigten Klassen-Namen um den sortierungsindex herauszubekommen:
                const classNameWithoutPrefix = cn.substr(prefix.length);
                const sortIndex = classNameToIndex(opts, classNameWithoutPrefix);
                let arr = res[sortIndex.toString()];
                if (!arr) {
                    arr = [];
                    res[sortIndex.toString()] = arr;
                }
                arr.push(cn);
            });
            const numberKeys = Object.keys(res).map(k => Number(k));
            numberKeys
                .sort((a, b) => a - b)
                .forEach(key => {
                orderedClassNameParts.push(res[key.toString()].sort().join(' '));
                if (opts.sortClassNamesUnknownClassesSeparator &&
                    key < 0 &&
                    numberKeys.some(k => k >= 0)) {
                    orderedClassNameParts.push(opts.sortClassNamesUnknownClassesSeparator);
                }
            });
        });
        return orderedClassNameParts;
    };
}
exports.defaultSortClassList = defaultSortClassList;
